
var		gRawData = "";

///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
function NewsItem(title, description, link)
{
	if (!title)
		this.title = new String("");
	else
	{
		this.title = new String(title);
		this.title = StripTags(this.title);
		this.title = DecodeHTMLEntities(this.title);
		this.title = RemoveWhiteSpace(this.title);
	}
	if (!description)
		this.description = new String("");
	else
	{
		this.description = new String(description)
		this.description = this.description.replace("\n", "\r");
		this.description = StripTags(this.description);
		this.description = DecodeHTMLEntities(this.description);
		this.description = RemoveWhiteSpace(this.description);
	}
	if (!link)
		this.link = new String("");
	else
	{
		this.link = new String(link);
		this.link = StripTags(this.link);
	}
	
    this.hidden = false;
    this.keep = true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedObject(feedURL, inHiddenList)
{
	this.LoadRaw			= FeedLoadRaw;
	this.ParseRawData		= FeedParseRawData;
	this.SearchHiddenList	= FeedSearchHiddenList;
	this.SaveHiddenList		= FeedSaveHiddenList;
	this.Refresh			= FeedRefresh;
	this.Hide				= FeedHide;
	this.ToggleOpen			= FeedToggleOpen;
	this.HideItem			= FeedHideItem;
	this.SetURL				= FeedSetURL;
	this.GetDisplayTitle	= FeedGetDisplayTitle;

	this.refreshInterval	= 30;
	this.open				= false;
	this.maxDisplayItems	= 50;
	
	if (inHiddenList)
		this.hiddenList = inHiddenList.split("+++");
	else
		this.hiddenList = new Array();

	this.SetURL(feedURL);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedSetURL(newURL)
{
	if (this.url)
	{
		if (this.url.toLowerCase() == newURL.toLowerCase())
			return false;
		if (this.hiddenList)
		{
			delete this.hiddenList;
			this.hiddenList = new Array();
		}
	}

	if (this.url)
		delete this.url;
	if (this.title)
		delete this.title;
	if (this.link)
		delete this.link;
	if (this.items)
		delete this.items;
	
	this.url = new String(newURL) || new String('');
	this.title = new String('');
	this.link = new String('');
	this.items = new Array();
	this.loaded = false;
	this.LoadRaw();
	
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedGetDisplayTitle()
{
	if (this.userTitle != "")
		return this.userTitle;
	if (this.title != "")
		return this.title;
	return this.url;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedHideItem(x)
{
	print("HideNewsItem - items[" + x + "].title = '" + this.items[x].title + "'");
	
	this.items[x].hidden = true;
	this.SaveHiddenList();
	
	UpdateGUI();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedToggleOpen(updateGUI)
{
	this.open = !this.open;
	
	SaveFeeds();
	
	if (updateGUI)
		UpdateGUI();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedRefresh()
{
	this.LoadRaw();

	if (system.event.modifiers.indexOf("option") > -1)
		return;

	for (var x = 0; x < this.items.length; x++)
	{
		this.items[x].hidden = false;
	}
	this.SaveHiddenList();
	UpdateGUI();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedHide()
{
	var		optionDown = false;
	var		numShownItems = 0;
	
	if (system.event.modifiers.indexOf("option") > -1)
		optionDown = true;

	for (var x = 0; x < this.items.length; x++)
	{
		if (!this.items[x].hidden)
		{
			if (!optionDown)
			{
				this.items[x].hidden = true;
			}
			else
			{
				if (numShownItems < this.maxDisplayItems)
				{
					this.items[x].hidden = true;
				}
			}
			if (numShownItems < this.maxDisplayItems)
				numShownItems++;
		}
	}
	this.SaveHiddenList();
	UpdateGUI();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedSearchHiddenList(searchText)
{
	for (var x = 0; x < this.hiddenList.length; x++)
	{
		if (this.hiddenList[x].toLowerCase() == searchText.toLowerCase())
		{
			//print("found hidden item - '" + this.hiddenList[x] + "'");
			return true;
		}
	}
	
	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedSaveHiddenList()
{
	if (this.items.length == 0)
	{
		// no items loaded - must have been an error, so don't recreate the hidden list
		// that way it'll still be there if it does successfully load any items
		return;
	}

	if (this.hiddenList)
		delete this.hiddenList;
	this.hiddenList = new Array();
	
	var		y = 0;
	
	for (var x = 0; x < this.items.length; x++)
	{
		if (this.items[x].hidden == true)
		{
			this.hiddenList[y] = this.items[x].title + this.items[x].link;
			y++
		}
	}
	
	SaveFeeds();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedParseRawData(theData)
{
	this.loaded = true;

	for (var y = 0; y < this.items.length; y++)
	{
		//print("clear keep on '" + this.items[y].title + "' (" + y + ")");
		this.items[y].keep = false;
	}

	// needed to reset xml parsers
	_Xparse_count = 0;
	
	var root;
	
	root = Xparse(theData);
	if (root)
		root = root.index[1];
	if (!root)
	{
		print("error parsing XML");
	}
	else
	{	
		var channel;
		
		channel = FeedGetElementsFromContents(root, "channel")[0];
		if (channel == null)
		{
			channel = root;
		}
		
		this.title = new String(FeedGetElementsFromContents(channel, "title")[0].contents);
		//print("title: " + this.title);
		this.link =	new String(FeedGetElementsFromContents(channel, "link")[0].contents);
		if (this.link == "")
			this.link = GetAtomLink(channel);
		//print("link: " + this.link);
		
		var 	itemsText;
		
		itemsText = FeedGetElementsFromContents(channel, "item");
		if (itemsText.length < 1)
			itemsText = FeedGetElementsFromContents(root, "item");
		if (itemsText.length < 1 )
			itemsText = FeedGetElementsFromContents(channel, "entry");
		if (itemsText.length < 1 )
			itemsText = FeedGetElementsFromContents(root, "entry");
		
		var		splicePos = 0;
	
		for (var x = 0; x < itemsText.length; x++)
		{
			var	descriptions;
			var theTitle;
			var theDescription;
			var theLink;
			
			descriptions = FeedGetElementsFromContents(itemsText[x], "description");
			if (descriptions.length == 0)
				descriptions = FeedGetElementsFromContents(itemsText[x], "content");
			if (descriptions.length > 0)
				theDescription = descriptions[0];
			
			theTitle = FeedGetElementsFromContents(itemsText[x], "title")[0];
			//theDescription = FeedGetElementsFromContents(itemsText[x], "description")[0];
			var	links = FeedGetElementsFromContents(itemsText[x], "link");
			if (links.length > 0)
				theLink = links[0].contents;
			if (theLink == "")
				theLink = GetAtomLink(itemsText[x]);
			//print("link = \"" + theLink + "\"");
			
			var		aNewsItems;
			
			aNewsItem = new NewsItem(theTitle, theDescription, theLink);
			if (aNewsItem)
			{
				var		string1 = aNewsItem.title + aNewsItem.link
				var		foundItem = false;
						
				for (var y = 0; y < this.items.length; y++)
				{
					var		string2 = this.items[y].title + this.items[y].link
				
					if (string1.toLowerCase() == string2.toLowerCase())
					{
						//print("found item '" + this.items[y].title + "' (" + y + ")");
						this.items[y].keep = true;
						foundItem = true;
						splicePos = y + 1;
						break;
					}
				}
				
				if (foundItem == false)
				{
					//print("splicing in item '" + aNewsItem.title + "'");
	
					if (this.SearchHiddenList(string1))
					{
						//print("hiding - '" + aNewsItem.title + "', '" + aNewsItem.link + "'");
						aNewsItem.hidden = true;	
					}
	
					this.items.splice(splicePos, 0, aNewsItem);
					splicePos++;
				}
			}
		}
	}
	
	UpdateGUI();
	this.SaveHiddenList();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedLoadRaw()
{
	if (IsValidURL(this.url))
	{
		//runCommandInBg("curl -w '|||%{url_effective}' -f -s -L --connect-timeout 10 --max-time 30 " + this.url, "gRawData");
		var		theURL = new URL();
		
		theURL.location = this.url;
		theURL.fetchAsync(HandleRawData);
		//var		rawData = urlFetcher.fetchAsync(this.url);
		//this.ParseRawData(rawData);
	}
	else
	{
		this.ParseRawData("");
	}

	this.timerCounter = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function GetAtomLink(el)
{
	//print("GetAtomLink");
	for (var x = 0; x < el.contents.length; x++)
	{
		if (el.contents[x].name == "link")
		{
			//print("attrib[rel] = " + el.contents[x].attributes["rel"]);
			if (el.contents[x].attributes["rel"] == "alternate")
			{
				//print("found atom link - " +  el.contents[x].attributes["href"]);
				return el.contents[x].attributes["href"];
			}
		}
	}
	return "";
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function FeedGetElementsFromContents(el, tagName)
{
	var children = new Array();
	//print("searching: "+ el.name + "(" + el.type + ")" + "\n" + el.toString() + "\n----\n");
	//print("for: " + tagName);
	
	// go through root index to find each item tag
	var z = 0;
	
	for (var x = 0; x < el.contents.length; x++)
	{
		if (el.contents[x].name == tagName)
		{
			//print("adding "+el.contents[x].name+ ":(" + z+") to elements");
			children[z] = el.contents[x];
			z++;
		}
	}
	
	return children;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
function HandleRawData(theURL)
{
	//print("raw data coming in from - " + theURL.location);
	for (var x = 0; x < gFeedArray.length; x++)
	{
		if (gFeedArray[x].url.toLowerCase() == theURL.location.toLowerCase())
		{
			//print("response: " + theURL.response);
			//print("result: " + theURL.result);
			gFeedArray[x].ParseRawData(theURL.result);
		}
	}
}
/*
function HandleRawData(theData, theURL)
{
	print("raw data coming in from - " + theURL);
	for (var x = 0; x < gFeedArray.length; x++)
	{
		if (gFeedArray[x].url.toLowerCase() == theURL.toLowerCase())
		{
			gFeedArray[x].ParseRawData(theData);
		}
	}
}
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
function AddEditFeed(feedObject)
{
	var		formFields = new Array();
	var		formResult;
	var		formTitle = "Add News Feed";
	
	formFields[0] = new FormField();
	formFields[0].type = "text";
	formFields[0].title = "Feed URL:";
	formFields[0].description = "The source URL for the news feed.";
	formFields[0].defaultValue = "";
	if (feedObject)
		formFields[0].defaultValue = feedObject.url;
	
	formFields[1] = new FormField();
	formFields[1].type = "text";
	formFields[1].title = "Display Title:";
	formFields[1].description = "An alternative display title for the news feed - leave blank to obtain the title from the news feed itself."
	formFields[1].defaultValue = "";
	if (feedObject)
		formFields[1].defaultValue = feedObject.userTitle;

	formFields[2] = new FormField();
	formFields[2].type = "text";
	formFields[2].title = "Number of items:";
	formFields[2].description = "The maximum number of items to display for this news feed."
	formFields[2].defaultValue = 10;
	if (feedObject)
		formFields[2].defaultValue = feedObject.maxDisplayItems;
	
	formFields[3] = new FormField();
	formFields[3].type = "text";
	formFields[3].title = "Refresh Interval:";
	formFields[3].description = "The number of minutes to wait before reloading this news feed.\rNOTE: The minimum value is 30 minutes, lower refresh intervals would generate excessive network traffic."
	formFields[3].defaultValue = 30;
	if (feedObject)
		formFields[3].defaultValue = feedObject.refreshInterval;
	
	if (feedObject)
		formTitle = "Edit News Feed";
	
	do
	{
		formResult = form(formFields, formTitle, "OK", "Cancel");
		if (!formResult)
			return;
	
		if (!IsValidURL(formResult[0]))	
			alert("\"Feed URL\" is not a valid URL.");
		else if (!parseInt(formResult[2]) || parseInt(formResult[2]) <= 0)
			alert("\"Number of items\" is not a valid number.");
		else if (!parseInt(formResult[3]) || parseInt(formResult[3]) < 30)
			alert("\"Refresh Interval\" is not a valid number.");
		else
			break;
		
		formFields[0].defaultValue = formResult[0];
		formFields[1].defaultValue = formResult[1];
		formFields[2].defaultValue = formResult[2];
		formFields[3].defaultValue = formResult[3];
		
	} while (true);
	
	if (feedObject)
	{
		var		updateGUI = false;
	
		if (feedObject.userTitle != formResult[1])
		{
			feedObject.userTitle = formResult[1];
			updateGUI = true;
		}
		feedObject.refreshInterval = formResult[3];
		if (parseInt(formResult[2]) != feedObject.maxDisplayItems)
		{
			feedObject.maxDisplayItems = parseInt(formResult[2]);
			updateGUI = true;
		}
		if (feedObject.SetURL(formResult[0]))
		{
			updateGUI = true;
		}
		if (updateGUI)
			UpdateGUI();
		SaveFeeds();
	}
	else
	{	
		AddFeedObject(formResult[0], "0", formResult[1], formResult[2], formResult[3], "");
		SaveFeeds();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function RemoveFeed(z)
{
	if (alert("Remove \"" + gFeedArray[z].GetDisplayTitle() + "\" news feed?", "Yes", "No") != 1)
		return;

	gFeedArray.splice(z, 1);
	SaveFeeds();
	UpdateGUI();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function AddFeedObject(feedURLText, isOpenText, inUserTitle, maxDisplayItemsText, refreshInterval, hiddenList)
{
	var		feedPos = gFeedArray.length;

	print("FeedURL[" + feedPos + "] = { " + feedURLText + ", " + isOpenText + ", " + maxDisplayItemsText + " }");
	
	gFeedArray.splice(feedPos, 0, new FeedObject(feedURLText, hiddenList));
	if (isOpenText == "1")
		gFeedArray[feedPos].open = true;
	gFeedArray[feedPos].userTitle = inUserTitle;
	gFeedArray[feedPos].maxDisplayItems = parseInt(maxDisplayItemsText);
	gFeedArray[feedPos].refreshInterval = parseInt(refreshInterval);
	UpdateGUI();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function LoadFeeds()
{
	var feedURLArray;
	
		// remove all current feed objects, and the items within them
	for (var x = (gFeedArray.length - 1); x >= 0; x--)
	{
		for (var y = gFeedArray[x].items.length - 1; y >= 0; y--)
		{
			gFeedArray[x].items.splice(y, 1); 
		}
		gFeedArray.splice(x, 1);
	}
	
	var		feedsTextArray;
	
	//print("feedsText (load) = '" + preferences.feedList.value + "'");
	
	feedsTextArray = preferences.feedList.value.split("|||");
	for (var z = 0; z < feedsTextArray.length; z++)
	{
		var		feedTextArray = feedsTextArray[z].split("---");
	
		if (feedTextArray[0] != "")
		{
			AddFeedObject(feedTextArray[0], feedTextArray[1], feedTextArray[2], feedTextArray[3], feedTextArray[4], feedTextArray[5]);
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function SaveFeeds()
{
	preferences.feedList.value = "";

	for (var x = 0; x < gFeedArray.length; x++)
	{
		if (preferences.feedList.value != "")
			preferences.feedList.value += "|||";
	
		preferences.feedList.value += gFeedArray[x].url + "---";
		if (gFeedArray[x].open)
			preferences.feedList.value += "1";
		else
			preferences.feedList.value += "0";
		preferences.feedList.value += "---" + gFeedArray[x].userTitle;
		preferences.feedList.value += "---" + gFeedArray[x].maxDisplayItems;
		preferences.feedList.value += "---" + gFeedArray[x].refreshInterval;
		preferences.feedList.value += "---" + gFeedArray[x].hiddenList.join("+++");
	}

	//print("feedsText (save) = '" + preferences.feedList.value + "'");
	
	savePreferences();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function DoTimer()
{
	for (var z = 0; z < gFeedArray.length; z++)
	{
		gFeedArray[z].timerCounter++;
		if (gFeedArray[z].refreshInterval < 30)
			gFeedArray[z].refreshInterval = 30;
		if (gFeedArray[z].timerCounter >= gFeedArray[z].refreshInterval)
		{
			print("Refreshing feed " + gFeedArray[z].GetDisplayTitle());
			gFeedArray[z].LoadRaw();
			gFeedArray[z].timerCounter = 0;
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

var	theHTMLEntitiesArray;

///////////////////////////////////////////////////////////////////////////////////////////////////
function RemoveWhiteSpace(theString)
{
	theString = theString.replace(/\r\r/gi, "\r");
	theString = theString.replace(/^[\s\r]*/, "");
	return theString.replace(/[\s\r]*$/, "");
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function StripTags(theString)
{
	theString = theString.replace(/<br\/>/gi, "\r");
	return theString.replace(/<\/?[^>]*>/g, "");
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function IsValidURL(theString)
{
	if (theString.match(/http:\/\/[a-z0-9\.-]+\/.*/i))
		return true;

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function DecodeHTMLEntities(theString)
{
	if (!theHTMLEntitiesArray)
	{
		theHTMLEntitiesArray = new Array();
	
		theHTMLEntitiesArray["&quot;"] = "\"";	// quotation mark
		theHTMLEntitiesArray["&#34;"] = "\"";	// quotation mark 
		
		theHTMLEntitiesArray["&apos;"] = "'";	// quotation mark
	
		theHTMLEntitiesArray["&amp;"] = "&";	// ampersand
		theHTMLEntitiesArray["&#38;"] = "&";	// ampersand 
		theHTMLEntitiesArray["&#038;"] = "&";	// ampersand 
		
		theHTMLEntitiesArray["&#39;"] = "'";	// ampersand 
		theHTMLEntitiesArray["&#039;"] = "'";	// ampersand 

		theHTMLEntitiesArray["&lt;"] = "<";		// less-than
		theHTMLEntitiesArray["&#60;"] = "<";	// less-than 
		theHTMLEntitiesArray["&#060;"] = "<";	// less-than 
		
		theHTMLEntitiesArray["&gt;"] = ">";		// greater-than
		theHTMLEntitiesArray["&#62;"] = ">";	// greater-than 
		theHTMLEntitiesArray["&#062;"] = ">";	// greater-than 
		
		theHTMLEntitiesArray["&#92;"] = "\\";	// greater-than 
		theHTMLEntitiesArray["&#092;"] = "\\";	// greater-than 

		theHTMLEntitiesArray["&hellip;"] = "…";	// greater-than 
		theHTMLEntitiesArray["&#133;"] = "…";	// greater-than 

		theHTMLEntitiesArray["&lsquo;"] = "'";	// greater-than
		theHTMLEntitiesArray["&#145;"] = "'";	// greater-than 
		theHTMLEntitiesArray["&rsquo;"] = "'";	// greater-than
		theHTMLEntitiesArray["&#146;"] = "'";	// greater-than 
		theHTMLEntitiesArray["&ldquo;"] = "\"";	// greater-than
		theHTMLEntitiesArray["&#147;"] = "\"";	// greater-than 
		theHTMLEntitiesArray["&rdquo;"] = "\"";	// greater-than
		theHTMLEntitiesArray["&#148;"] = "\"";	// greater-than 

		theHTMLEntitiesArray["&#151;"] = "-";	// greater-than 
	
		theHTMLEntitiesArray["&nbsp;"] = "¬†";	// non-breaking space
		theHTMLEntitiesArray["&#160;"] = "¬†";	// non-breaking space 
		
		theHTMLEntitiesArray["&iexcl;"] = "¬°";	// inverted exclamation mark
		theHTMLEntitiesArray["&#161;"] = "¬°";	// inverted exclamation mark 
		
		theHTMLEntitiesArray["&curren;"] = "¬§"; // currency
		theHTMLEntitiesArray["&#164;"] = "¬§"; // currency 
		
		theHTMLEntitiesArray["&cent;"] = "¬¢"; // cent
		theHTMLEntitiesArray["&#162;"] = "¬¢"; // cent 
		
		theHTMLEntitiesArray["&pound;"] = "¬£"; // pound
		theHTMLEntitiesArray["&#163;"] = "¬£"; // pound 
		
		theHTMLEntitiesArray["&yen;"] = "¬•"; // yen
		theHTMLEntitiesArray["&#165;"] = "¬•"; // yen 
		
		theHTMLEntitiesArray["&brvbar;"] = "¬¶"; // broken vertical bar
		theHTMLEntitiesArray["&#166;"] = "¬¶"; // broken vertical bar 
		
		theHTMLEntitiesArray["&sect;"] = "¬ß"; // section
		theHTMLEntitiesArray["&#167;"] = "¬ß"; // section 
		
		theHTMLEntitiesArray["&uml;"] = "¬®"; // spacing diaeresis
		theHTMLEntitiesArray["&#168;"] = "¬®"; // spacing diaeresis 
		
		theHTMLEntitiesArray["&copy;"] = "¬©"; // copyright
		theHTMLEntitiesArray["&#169;"] = "¬©"; // copyright 
		
		theHTMLEntitiesArray["&ordf;"] = "¬™"; // feminine ordinal indicator
		theHTMLEntitiesArray["&#170;"] = "¬™"; // feminine ordinal indicator 
		
		theHTMLEntitiesArray["&laquo;"] = "¬´"; // angle quotation mark (left)
		theHTMLEntitiesArray["&#171;"] = "¬´"; // angle quotation mark (left) 
		
		theHTMLEntitiesArray["&not;"] = "¬¨"; // negation
		theHTMLEntitiesArray["&#172;"] = "¬¨"; // negation 
		
		theHTMLEntitiesArray["&shy;"] = "¬≠"; // soft hyphen
		theHTMLEntitiesArray["&#173;"] = "¬≠"; // soft hyphen 
		
		theHTMLEntitiesArray["&reg;"] = "¬Æ"; // registered trademark
		theHTMLEntitiesArray["&#174;"] = "¬Æ"; // registered trademark 
		
		theHTMLEntitiesArray["&macr;"] = "¬Ø"; // spacing macron
		theHTMLEntitiesArray["&#175;"] = "¬Ø"; // spacing macron 
		
		theHTMLEntitiesArray["&deg;"] = "¬∞"; // degree
		theHTMLEntitiesArray["&#176;"] = "¬∞"; // degree 
		
		theHTMLEntitiesArray["&plusmn;"] = "¬±"; // plus-or-minus¬†
		theHTMLEntitiesArray["&#177;"] = "¬±"; // plus-or-minus¬† 
		
		theHTMLEntitiesArray["&sup2;"] = "¬≤"; // superscript 2
		theHTMLEntitiesArray["&#178;"] = "¬≤"; // superscript 2 
		
		theHTMLEntitiesArray["&sup3;"] = "¬≥"; // superscript 3
		theHTMLEntitiesArray["&#179;"] = "¬≥"; // superscript 3 
		
		theHTMLEntitiesArray["&acute;"] = "¬¥"; // spacing acute
		theHTMLEntitiesArray["&#180;"] = "¬¥"; // spacing acute 
		
		theHTMLEntitiesArray["&micro;"] = "¬µ"; // micro
		theHTMLEntitiesArray["&#181;"] = "¬µ"; // micro 
		
		theHTMLEntitiesArray["&para;"] = "¬∂"; // paragraph
		theHTMLEntitiesArray["&#182;"] = "¬∂"; // paragraph 
		
		theHTMLEntitiesArray["&middot;"] = "¬∑"; // middle dot
		theHTMLEntitiesArray["&#183;"] = "¬∑"; // middle dot 
		
		theHTMLEntitiesArray["&cedil;"] = "¬∏"; // spacing cedilla
		theHTMLEntitiesArray["&#184;"] = "¬∏"; // spacing cedilla 
		
		theHTMLEntitiesArray["&sup1;"] = "¬π"; // superscript 1
		theHTMLEntitiesArray["&#185;"] = "¬π"; // superscript 1 
		
		theHTMLEntitiesArray["&ordm;"] = "¬∫"; // masculine ordinal indicator
		theHTMLEntitiesArray["&#186;"] = "¬∫"; // masculine ordinal indicator 
		
		theHTMLEntitiesArray["&raquo;"] = "¬ª"; // angle quotation mark (right)
		theHTMLEntitiesArray["&#187;"] = "¬ª"; // angle quotation mark (right) 
		
		theHTMLEntitiesArray["&frac14;"] = "¬º"; // fraction 1/4
		theHTMLEntitiesArray["&#188;"] = "¬º"; // fraction 1/4 
		
		theHTMLEntitiesArray["&frac12;"] = "¬Ω"; // fraction 1/2
		theHTMLEntitiesArray["&#189;"] = "¬Ω"; // fraction 1/2 
		
		theHTMLEntitiesArray["&frac34;"] = "¬æ"; // fraction 3/4
		theHTMLEntitiesArray["&#190;"] = "¬æ"; // fraction 3/4 
		
		theHTMLEntitiesArray["&iquest;"] = "¬ø"; // inverted question mark
		theHTMLEntitiesArray["&#191;"] = "¬ø"; // inverted question mark 
		
		theHTMLEntitiesArray["&times;"] = "√ó"; // multiplication
		theHTMLEntitiesArray["&#215;"] = "√ó"; // multiplication 
		
		theHTMLEntitiesArray["&divide;"] = "√∑"; // division
		theHTMLEntitiesArray["&#247;"] = "√∑"; // division 
		
		theHTMLEntitiesArray["&Agrave;"] = "√Ä"; // capital a, grave accent
		theHTMLEntitiesArray["&#192;"] = "√Ä"; // capital a, grave accent 
		
		theHTMLEntitiesArray["&Aacute;"] = "√Å"; // capital a, acute accent
		theHTMLEntitiesArray["&#193;"] = "√Å"; // capital a, acute accent 
		
		theHTMLEntitiesArray["&Acirc;"] = "√Ç"; // capital a, circumflex accent
		theHTMLEntitiesArray["&#194;"] = "√Ç"; // capital a, circumflex accent 
		
		theHTMLEntitiesArray["&Atilde;"] = "√É"; // capital a, tilde
		theHTMLEntitiesArray["&#195;"] = "√É"; // capital a, tilde 
		
		theHTMLEntitiesArray["&Auml;"] = "√Ñ"; // capital a, umlaut mark
		theHTMLEntitiesArray["&#196;"] = "√Ñ"; // capital a, umlaut mark 
		
		theHTMLEntitiesArray["&Aring;"] = "√Ö"; // capital a, ring
		theHTMLEntitiesArray["&#197;"] = "√Ö"; // capital a, ring 
		
		theHTMLEntitiesArray["&AElig;"] = "√Ü"; // capital ae
		theHTMLEntitiesArray["&#198;"] = "√Ü"; // capital ae 
		
		theHTMLEntitiesArray["&Ccedil;"] = "√á"; // capital c, cedilla
		theHTMLEntitiesArray["&#199;"] = "√á"; // capital c, cedilla 
		
		theHTMLEntitiesArray["&Egrave;"] = "√à"; // capital e, grave accent
		theHTMLEntitiesArray["&#200;"] = "√à"; // capital e, grave accent 
		
		theHTMLEntitiesArray["&Eacute;"] = "√â"; // capital e, acute accent
		theHTMLEntitiesArray["&#201;"] = "√â"; // capital e, acute accent 
		
		theHTMLEntitiesArray["&Ecirc;"] = "√ä"; // capital e, circumflex accent
		theHTMLEntitiesArray["&#202;"] = "√ä"; // capital e, circumflex accent 
		
		theHTMLEntitiesArray["&Euml;"] = "√ã"; // capital e, umlaut mark
		theHTMLEntitiesArray["&#203;"] = "√ã"; // capital e, umlaut mark 
		
		theHTMLEntitiesArray["&Igrave;"] = "√å"; // capital i, grave accent
		theHTMLEntitiesArray["&#204;"] = "√å"; // capital i, grave accent 
		
		theHTMLEntitiesArray["&Iacute;"] = "√ç"; // capital i, acute accent
		theHTMLEntitiesArray["&#205;"] = "√ç"; // capital i, acute accent 
		
		theHTMLEntitiesArray["&Icirc;"] = "√é"; // capital i, circumflex accent
		theHTMLEntitiesArray["&#206;"] = "√é"; // capital i, circumflex accent 
		
		theHTMLEntitiesArray["&Iuml;"] = "√è"; // capital i, umlaut mark
		theHTMLEntitiesArray["&#207;"] = "√è"; // capital i, umlaut mark 
		
		theHTMLEntitiesArray["&ETH;"] = "√ê"; // capital eth, Icelandic
		theHTMLEntitiesArray["&#208;"] = "√ê"; // capital eth, Icelandic 
		
		theHTMLEntitiesArray["&Ntilde;"] = "√ë"; // capital n, tilde
		theHTMLEntitiesArray["&#209;"] = "√ë"; // capital n, tilde 
		
		theHTMLEntitiesArray["&Ograve;"] = "√í"; // capital o, grave accent
		theHTMLEntitiesArray["&#210;"] = "√í"; // capital o, grave accent 
		
		theHTMLEntitiesArray["&Oacute;"] = "√ì"; // capital o, acute accent
		theHTMLEntitiesArray["&#211;"] = "√ì"; // capital o, acute accent 
		
		theHTMLEntitiesArray["&Ocirc;"] = "√î"; // capital o, circumflex accent
		theHTMLEntitiesArray["&#212;"] = "√î"; // capital o, circumflex accent 
		
		theHTMLEntitiesArray["&Otilde;"] = "√ï"; // capital o, tilde
		theHTMLEntitiesArray["&#213;"] = "√ï"; // capital o, tilde 
		
		theHTMLEntitiesArray["&Ouml;"] = "√ñ"; // capital o, umlaut mark
		theHTMLEntitiesArray["&#214;"] = "√ñ"; // capital o, umlaut mark 
		
		theHTMLEntitiesArray["&Oslash;"] = "√ò"; // capital o, slash
		theHTMLEntitiesArray["&#216;"] = "√ò"; // capital o, slash 
		
		theHTMLEntitiesArray["&Ugrave;"] = "√ô"; // capital u, grave accent
		theHTMLEntitiesArray["&#217;"] = "√ô"; // capital u, grave accent 
		
		theHTMLEntitiesArray["&Uacute;"] = "√ö"; // capital u, acute accent
		theHTMLEntitiesArray["&#218;"] = "√ö"; // capital u, acute accent 
		
		theHTMLEntitiesArray["&Ucirc;"] = "√õ"; // capital u, circumflex accent
		theHTMLEntitiesArray["&#219;"] = "√õ"; // capital u, circumflex accent 
		
		theHTMLEntitiesArray["&Uuml;"] = "√ú"; // capital u, umlaut mark
		theHTMLEntitiesArray["&#220;"] = "√ú"; // capital u, umlaut mark 
		
		theHTMLEntitiesArray["&Yacute;"] = "√ù"; // capital y, acute accent
		theHTMLEntitiesArray["&#221;"] = "√ù"; // capital y, acute accent 
		
		theHTMLEntitiesArray["&THORN;"] = "√û"; // capital THORN, Icelandic
		theHTMLEntitiesArray["&#222;"] = "√û"; // capital THORN, Icelandic 
		
		theHTMLEntitiesArray["&szlig;"] = "√ü"; // small sharp s, German
		theHTMLEntitiesArray["&#223;"] = "√ü"; // small sharp s, German 
		
		theHTMLEntitiesArray["&agrave;"] = "√†"; // small a, grave accent
		theHTMLEntitiesArray["&#224;"] = "√†"; // small a, grave accent 
		
		theHTMLEntitiesArray["&aacute;"] = "√°"; // small a, acute accent
		theHTMLEntitiesArray["&#225;"] = "√°"; // small a, acute accent 
		
		theHTMLEntitiesArray["&acirc;"] = "√¢"; // small a, circumflex accent
		theHTMLEntitiesArray["&#226;"] = "√¢"; // small a, circumflex accent 
		
		theHTMLEntitiesArray["&atilde;"] = "√£"; // small a, tilde
		theHTMLEntitiesArray["&#227;"] = "√£"; // small a, tilde 
		
		theHTMLEntitiesArray["&auml;"] = "√§"; // small a, umlaut mark
		theHTMLEntitiesArray["&#228;"] = "√§"; // small a, umlaut mark 
		
		theHTMLEntitiesArray["&aring;"] = "√•"; // small a, ring
		theHTMLEntitiesArray["&#229;"] = "√•"; // small a, ring 
		
		theHTMLEntitiesArray["&aelig;"] = "√¶"; // small ae
		theHTMLEntitiesArray["&#230;"] = "√¶"; // small ae 
		
		theHTMLEntitiesArray["&ccedil;"] = "√ß"; // small c, cedilla
		theHTMLEntitiesArray["&#231;"] = "√ß"; // small c, cedilla 
		
		theHTMLEntitiesArray["&egrave;"] = "√®"; // small e, grave accent
		theHTMLEntitiesArray["&#232;"] = "√®"; // small e, grave accent 
		
		theHTMLEntitiesArray["&eacute;"] = "√©"; // small e, acute accent
		theHTMLEntitiesArray["&#233;"] = "√©"; // small e, acute accent 
		
		theHTMLEntitiesArray["&ecirc;"] = "√™"; // small e, circumflex accent
		theHTMLEntitiesArray["&#234;"] = "√™"; // small e, circumflex accent 
		
		theHTMLEntitiesArray["&euml;"] = "√´"; // small e, umlaut mark
		theHTMLEntitiesArray["&#235;"] = "√´"; // small e, umlaut mark 
		
		theHTMLEntitiesArray["&igrave;"] = "√¨"; // small i, grave accent
		theHTMLEntitiesArray["&#236;"] = "√¨"; // small i, grave accent 
		
		theHTMLEntitiesArray["&iacute;"] = "√≠"; // small i, acute accent
		theHTMLEntitiesArray["&#237;"] = "√≠"; // small i, acute accent 
		
		theHTMLEntitiesArray["&icirc;"] = "√Æ"; // small i, circumflex accent
		theHTMLEntitiesArray["&#238;"] = "√Æ"; // small i, circumflex accent 
		
		theHTMLEntitiesArray["&iuml;"] = "√Ø"; // small i, umlaut mark
		theHTMLEntitiesArray["&#239;"] = "√Ø"; // small i, umlaut mark 
		
		theHTMLEntitiesArray["&eth;"] = "√∞"; // small eth, Icelandic
		theHTMLEntitiesArray["&#240;"] = "√∞"; // small eth, Icelandic 
		
		theHTMLEntitiesArray["&ntilde;"] = "√±"; // small n, tilde
		theHTMLEntitiesArray["&#241;"] = "√±"; // small n, tilde 
		
		theHTMLEntitiesArray["&ograve;"] = "√≤"; // small o, grave accent
		theHTMLEntitiesArray["&#242;"] = "√≤"; // small o, grave accent 
		
		theHTMLEntitiesArray["&oacute;"] = "√≥"; // small o, acute accent
		theHTMLEntitiesArray["&#243;"] = "√≥"; // small o, acute accent 
		
		theHTMLEntitiesArray["&ocirc;"] = "√¥"; // small o, circumflex accent
		theHTMLEntitiesArray["&#244;"] = "√¥"; // small o, circumflex accent 
		
		theHTMLEntitiesArray["&otilde;"] = "√µ"; // small o, tilde
		theHTMLEntitiesArray["&#245;"] = "√µ"; // small o, tilde 
		
		theHTMLEntitiesArray["&ouml;"] = "√∂"; // small o, umlaut mark
		theHTMLEntitiesArray["&#246;"] = "√∂"; // small o, umlaut mark 
		
		theHTMLEntitiesArray["&oslash;"] = "√∏"; // small o, slash
		theHTMLEntitiesArray["&#248;"] = "√∏"; // small o, slash 
		
		theHTMLEntitiesArray["&ugrave;"] = "√π"; // small u, grave accent
		theHTMLEntitiesArray["&#249;"] = "√π"; // small u, grave accent 
		
		theHTMLEntitiesArray["&uacute;"] = "√∫"; // small u, acute accent
		theHTMLEntitiesArray["&#250;"] = "√∫"; // small u, acute accent 
		
		theHTMLEntitiesArray["&ucirc;"] = "√ª"; // small u, circumflex accent
		theHTMLEntitiesArray["&#251;"] = "√ª"; // small u, circumflex accent 
		
		theHTMLEntitiesArray["&uuml;"] = "√º"; // small u, umlaut mark
		theHTMLEntitiesArray["&#252;"] = "√º"; // small u, umlaut mark 
		
		theHTMLEntitiesArray["&yacute;"] = "√Ω"; // small y, acute accent
		theHTMLEntitiesArray["&#253;"] = "√Ω"; // small y, acute accent 
		
		theHTMLEntitiesArray["&thorn;"] = "√æ"; // small thorn, Icelandic
		theHTMLEntitiesArray["&#254;"] = "√æ"; // small thorn, Icelandic 
		
		theHTMLEntitiesArray["&yuml;"] = "√ø"; // small y, umlaut mark
		theHTMLEntitiesArray["&#255;"] = "√ø"; // small y, umlaut mark 
		
		theHTMLEntitiesArray["&OElig;"] = "≈í"; // capital ligature OE
		theHTMLEntitiesArray["&#338;"] = "≈í"; // capital ligature OE 
		
		theHTMLEntitiesArray["&oelig;"] = "≈ì"; // small ligature oe
		theHTMLEntitiesArray["&#339;"] = "≈ì"; // small ligature oe 
		
		theHTMLEntitiesArray["&Scaron;"] = "≈†"; // capital S with caron
		theHTMLEntitiesArray["&#352;"] = "≈†"; // capital S with caron 
		
		theHTMLEntitiesArray["&scaron;"] = "≈°"; // small S with caron
		theHTMLEntitiesArray["&#353;"] = "≈°"; // small S with caron 
		
		theHTMLEntitiesArray["&Yuml;"] = "≈∏"; // capital Y with diaeres
		theHTMLEntitiesArray["&#376;"] = "≈∏"; // capital Y with diaeres 
		
		theHTMLEntitiesArray["&circ;"] = "ÀÜ"; // modifier letter circumflex accent
		theHTMLEntitiesArray["&#710;"] = "ÀÜ"; // modifier letter circumflex accent 
		
		theHTMLEntitiesArray["&tilde;"] = "Àú"; // small tilde
		theHTMLEntitiesArray["&#732;"] = "Àú"; // small tilde 
		theHTMLEntitiesArray["&ensp;"] = ""; // en space
		theHTMLEntitiesArray["&#8194;"] = ""; // en space 
		theHTMLEntitiesArray["&emsp;"] = ""; // em space
		theHTMLEntitiesArray["&#8195;"] = ""; // em space 
		theHTMLEntitiesArray["&thinsp;"] = ""; // thin space
		theHTMLEntitiesArray["&#8201;"] = ""; // thin space 
		
		theHTMLEntitiesArray["&zwnj;"] = "‚Äå"; // zero width non-joiner
		theHTMLEntitiesArray["&#8204;"] = "‚Äå"; // zero width non-joiner 
		
		theHTMLEntitiesArray["&zwj;"] = "‚Äç"; // zero width joiner
		theHTMLEntitiesArray["&#8205;"] = "‚Äç"; // zero width joiner 
	
		theHTMLEntitiesArray["&lrm;"] = "‚Äé"; // left-to-right mark
		theHTMLEntitiesArray["&#8206;"] = "‚Äé"; // left-to-right mark 
		
		theHTMLEntitiesArray["&rlm;"] = "‚Äè"; // right-to-left mark
		theHTMLEntitiesArray["&#8207;"] = "‚Äè"; // right-to-left mark 
		
		theHTMLEntitiesArray["&ndash;"] = "‚Äì"; // en dash
		theHTMLEntitiesArray["&#8211;"] = "‚Äì"; // en dash 
		
		theHTMLEntitiesArray["&mdash;"] = "‚Äî"; // em dash
		theHTMLEntitiesArray["&#8212;"] = "‚Äî"; // em dash 
		
		theHTMLEntitiesArray["&lsquo;"] = "‚Äò"; // left single quotation mark
		theHTMLEntitiesArray["&#8216;"] = "‚Äò"; // left single quotation mark 
		
		theHTMLEntitiesArray["&rsquo;"] = "'"; // right single quotation mark
		theHTMLEntitiesArray["&#8217;"] = "'"; // right single quotation mark 
		
		theHTMLEntitiesArray["&sbquo;"] = "‚Äö"; // single low-9 quotation mark
		theHTMLEntitiesArray["&#8218;"] = "‚Äö"; // single low-9 quotation mark 
		
		theHTMLEntitiesArray["&ldquo;"] = "‚Äú"; // left double quotation mark
		theHTMLEntitiesArray["&#8220;"] = "‚Äú"; // left double quotation mark 
		
		theHTMLEntitiesArray["&rdquo;"] = "‚Äù"; // right double quotation mark
		theHTMLEntitiesArray["&#8221;"] = "‚Äù"; // right double quotation mark 
		
		theHTMLEntitiesArray["&bdquo;"] = "‚Äû"; // double low-9 quotation mark
		theHTMLEntitiesArray["&#8222;"] = "‚Äû"; // double low-9 quotation mark 
		
		theHTMLEntitiesArray["&dagger;"] = "‚Ä†"; // dagger
		theHTMLEntitiesArray["&#8224;"] = "‚Ä†"; // dagger 
		
		theHTMLEntitiesArray["&Dagger;"] = "‚Ä°"; // double dagger
		theHTMLEntitiesArray["&#8225;"] = "‚Ä°"; // double dagger 
		
		theHTMLEntitiesArray["&permil;"] = "‚Ä∞"; // per mille¬†
		theHTMLEntitiesArray["&#8240;"] = "‚Ä∞"; // per mille¬† 
		
		theHTMLEntitiesArray["&lsaquo;"] = "‚Äπ"; // single left-pointing angle quotation
		theHTMLEntitiesArray["&#8249;"] = "‚Äπ"; // single left-pointing angle quotation 
		
		theHTMLEntitiesArray["&rsaquo;"] = "‚Ä∫"; // single right-pointing angle quotation
		theHTMLEntitiesArray["&#8250;"] = "‚Ä∫"; // single right-pointing angle quotation 
		
		theHTMLEntitiesArray["&euro;"] = "‚Ç¨"; // euro
		theHTMLEntitiesArray["&#8364;"] = "‚Ç¨"; // euro 
		
		theHTMLEntitiesArray["&trade;"] = "‚Ñ¢"; // trademark
		theHTMLEntitiesArray["&#8482;"] = "‚Ñ¢"; // trademark
	}

	var		matchesArray;
	var		x
	
	matchesArray = theString.match(/&([a-zA-Z0-9#]+);/gi);
	if(matchesArray)
	{
		for (x = 0; x < matchesArray.length; x++)
		{
			if (!theHTMLEntitiesArray[matchesArray[x]])
			{
				print("unknown entity - '" + matchesArray[x] + "'");
			}
			else
			{
				//print("replacing entity '" + matchesArray[x] + "' with '" + theHTMLEntitiesArray[matchesArray[x]] + "'");
				theString = theString.replace(matchesArray[x], theHTMLEntitiesArray[matchesArray[x]]);
			}
		}
	}
	
	return theString;
}
///////////////////////////////////////////////////////////////////////////////////////////////////